//
//  YHServiceListViewController.swift
//  galaxy
//
//  Created by EDY on 2024/4/8.
//  Copyright © 2024 https://www.galaxy-immi.com. All rights reserved.
//

import UIKit
import JXSegmentedView

class YHServiceListViewController: YHBaseViewController {

    let homeViewModel: YHHomePageViewModel = YHHomePageViewModel()
    var normalView: YHServerNoOrderView!
    var classId: Int = 0
    override func viewDidLoad() {
        super.viewDidLoad()
        setupUI()
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        loadData()
    }
}

extension YHServiceListViewController {
    func loadData() {
        self.normalView.tableHeadView.bannarView.dataArr = [YHBannerModel.localDefaultItem()]

        homeViewModel.getHomeBanner(1){[weak self] success, error in
            guard let self = self else { return }
            self.normalView.tableHeadView.bannarView.dataArr = self.homeViewModel.banners ?? [YHBannerModel.localDefaultItem()]
        }
        
        homeViewModel.getHomeClassify{[weak self] success, error in
            guard let self = self, let classify = self.homeViewModel.classify  else { return }
            for item in classify {
                let model = item as YHHomeClassifyModel
                if model.id == 1 {
                    self.normalView.sectionView.items = model.children
                    if self.classId == 0 {
                        let classifyID = model.children.first?.id ?? 0
                        self.classId = classifyID
                        self.homeViewModel.getList(true, classifyID) {[weak self] success, error in
                            guard let self = self else { return }
                            self.normalView.dataSouce = self.homeViewModel.arrHomeNewsData ?? []
                            if self.homeViewModel.hasMoreForHomeNews == false {
                                self.normalView.homeTableView.es.noticeNoMoreData()
                            }
                        }
                    }
                }
            }
        }
    }
    
    func setupUI() {
        gk_navBarAlpha = 0
        gk_navigationBar.isHidden = true
        
        normalView = {
            let view = YHServerNoOrderView()
            view.sectionBlock = {[weak self] model in
                guard let self = self else { return }
                self.classId = model.id
                self.homeViewModel.getList(true, model.id) {[weak self] success, error in
                    guard let self = self else { return }
                    self.normalView.dataSouce = self.homeViewModel.arrHomeNewsData ?? []
                    if self.homeViewModel.hasMoreForHomeNews == false {
                        self.normalView.homeTableView.es.noticeNoMoreData()
                    }
                }
            }
            view.loadMoreBlock = {[weak self] model in
                guard let self = self else { return }
                self.homeViewModel.getList(false, self.classId) {[weak self] success, error in
                    guard let self = self else { return }
                    self.normalView.homeTableView.es.stopLoadingMore()
                    self.normalView.dataSouce = self.homeViewModel.arrHomeNewsData ?? []
                    if self.homeViewModel.hasMoreForHomeNews == false {
                        self.normalView.homeTableView.es.noticeNoMoreData()
                    }
                }
            }
            return view
        }()
        view.addSubview(normalView)
        normalView.snp.makeConstraints { make in
            make.top.left.right.equalToSuperview()
            make.bottom.equalToSuperview()
        }
        
    }
}

extension YHServiceListViewController: JXSegmentedListContainerViewListDelegate {
    func listView() -> UIView {
        return view
    }
    
    func listWillAppear() {
        loadData()
    }
}
