//
//  YHMsgListModel.swift
//  galaxy
//
//  Created by edy on 2024/4/15.
//  Copyright © 2024 https://www.galaxy-immi.com. All rights reserved.
//

import UIKit
import SmartCodable

enum YHMessageType: Int {
    case none = 0
    case infoFill = 1   // 资料填写
    case cerUpload = 2  // 证件上传
    case draft = 3      // 文书定稿
    case fileSign = 4   // 文件签字
}

class YHMessageInfoModel: SmartCodable {
    var unreadCount: Int = 0
    var lastMessage: String = ""
    var lastMessageTime: Int = 0
    var type: Int = 0
    
    var customType: YHMessageType = .none
    
    required init() {
        
    }

    enum CodingKeys: String, CodingKey {
        case unreadCount = "unread_count"
        case lastMessage = "last_message"
        case lastMessageTime = "last_message_time"
        case type
    }
}

class YHMsgListModel: SmartCodable {
    var information: YHMessageInfoModel?
    var certificate: YHMessageInfoModel?
    var draft: YHMessageInfoModel?
    var signature: YHMessageInfoModel?
    
    required init() {
        
    }
}

class YHDetailMessageModel: SmartCodable {
    var id: String = ""
    var title: String = ""
    var content: String = ""
    var time: Int = 0
    var isRead: Bool = false
    
    required init() {
        
    }
}
